/*
 * Copyright (C) 2000 Free Software Foundation, Inc.
 * Brian Satterfield <legowhore@legowhore.com>, 2000.
 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package com.legowhore.q3;

import javax.swing.JPanel;
import javax.swing.JList;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.DefaultListModel;
import javax.swing.ListSelectionModel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Color;
import java.util.Vector;

public class BotsPanel extends JPanel {

    static JList botList;
    DefaultListModel botModel;

    JComboBox botSkill;
    JButton addButton;

    JScrollPane scrollPane;

    //  parent
    Q3ServerKit q3Gui;

    public BotsPanel(Q3ServerKit q3Gui) {
	this.q3Gui = q3Gui;
	
	setLayout(new PercentLayout());
	botModel = new DefaultListModel();
	botModel.addElement("Anarki");
	botModel.addElement("Angel");
	botModel.addElement("Biker");
	botModel.addElement("Bitterman");
	botModel.addElement("Bones");
	botModel.addElement("Cadvre");
	botModel.addElement("Crash");
	botModel.addElement("Daemia");
	botModel.addElement("Doom");
	botModel.addElement("Gorre");
	botModel.addElement("Grunt");
	botModel.addElement("Hossman");
	botModel.addElement("Hunter");
	botModel.addElement("Keel");
	botModel.addElement("Klesk");
	botModel.addElement("Lucy");
	botModel.addElement("Major");
	botModel.addElement("Mynx");
	botModel.addElement("Orbb");
	botModel.addElement("Patriot");
	botModel.addElement("Phobos");
	botModel.addElement("Ranger");
	botModel.addElement("Razor");
	botModel.addElement("Sarge");
	botModel.addElement("Slash");
	botModel.addElement("Sorlag");
	botModel.addElement("Stripe");
	botModel.addElement("TankJr");
	botModel.addElement("Uriel");
	botModel.addElement("Visor");
	botModel.addElement("Wrack");
	botModel.addElement("Xaero");
	botList = new JList(botModel);
	botList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	scrollPane = new JScrollPane(botList);
	
	addButton = new JButton("add");
        addButton.addActionListener(new AddListener());
	addButton.setBackground(Color.black);
	addButton.setForeground(Color.white);

	//  list of all the bot skills
	Vector skills = new Vector();
	skills.addElement("nightmare");
	skills.addElement("hardcore");
	skills.addElement("hurt me");
	skills.addElement("easy");
	skills.addElement("wuss");
	botSkill = new JComboBox(skills);
	botSkill.setBackground(Color.black);
	botSkill.setForeground(Color.white);

	add(scrollPane, "0 0 100 83");
	add(botSkill, "0 85 62 100");
	add(addButton, "64 85 100 100");
	setBackground(Color.black);
    }

    //  listens for an addbot request
    class AddListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
	    //  add the bot
	    int skill = 3;
	    String skillName = (String) botSkill.getSelectedItem();
	    if(skillName.equals("nightmare")) 
		skill = 4;
	    if(skillName.equals("hardcore")) 
		skill = 3;
	    if(skillName.equals("hurt me")) 
		skill = 2;
	    if(skillName.equals("easy")) 
		skill = 1;
	    if(skillName.equals("wuss")) 
		skill = 0;

	    String response 
		= q3Gui.q3Client.send("addbot " 
				+ (String) botList.getSelectedValue() 
				+ " " + skill);
	    if(response.indexOf("maxclients") > 0) {
		q3Gui.effectsPanel.setText("Server full.");
		return;
	    }
	    if(response.indexOf("password") > 0) {
		q3Gui.effectsPanel.setText("Invalid password");
		//  switch to the password command...
		q3Gui.newAction("pass");
		return;
	    }
	    if(response.indexOf("not defined") > 0) {
		q3Gui.effectsPanel.setText("Bot " 
				   + (String) botList.getSelectedValue() 
				   + " not defined");
		return;
	    }
	    if(response.indexOf("failed") > 0) {
		q3Gui.effectsPanel.setText("Could not create bot");
		return;
	    }
	    if(response.indexOf("not contact") > 0) {
		q3Gui.effectsPanel.setText("Could not contact server.");
		return;
	    }
	    q3Gui.effectsPanel.setText((String) botList.getSelectedValue() 
			       + " entered the game");
        }
    }


    private void db(String s) {
	System.err.println(s);
    }
    
}
