/*
 * Copyright (C) 2000 Free Software Foundation, Inc.
 * Brian Satterfield <legowhore@legowhore.com>, 2000.
 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package com.legowhore.q3;

import java.awt.Color;
import java.awt.Font;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.*;

//  well, it happened...this program has grown 
//  enough to send email :)
public class FeedbackPanel extends JPanel {

    //  parent
    Q3ServerKit q3Gui;

    //  text area
    JTextArea textArea; 

    //  send button
    JButton sendButton;

    JScrollPane scrollPane;

    Font smallFont;

    String startText;

    //  some flags to prevent flooding me :P
    boolean hasSentBefore = false;
    long timeLastSent = 0;
    long currentTime;

    public FeedbackPanel(Q3ServerKit q3Gui) {
	this.q3Gui = q3Gui;
	this.setLayout(new PercentLayout());
	
	this.setBackground(Color.black);

	Border etched = BorderFactory.createEtchedBorder();
	this.setBorder(etched);

	smallFont = new Font("plain", Font.PLAIN, 10); 

	textArea = new JTextArea();
	textArea.setEditable(true);
	textArea.setFont(smallFont);
	textArea.setLineWrap(true);

	sendButton = new JButton("email lego");
	sendButton.setBackground(Color.black);
	sendButton.setForeground(Color.yellow);
	sendButton.addActionListener(new SendListener());

	startText = ("Dear Lego,\n\n<your message>\n\nRegards,"
		     + "\n\n<your name>\n<your email>");

	textArea.setText(startText);
	scrollPane = new JScrollPane(textArea);

	
	add(scrollPane, "0 0 100 85");
	add(sendButton, "0 88 100 100");
	
    }

    //  listens for a send request
    class SendListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    String announcement = "";
	    boolean allOk = true;
	    
	    //  used to set the mail proggy used
	    String mailApp = "";

	    //  check for /bin/mail
	    File mail = new File("/bin/mail");
	    if(!mail.exists()) {
		announcement = "Could not find '/bin/mail'";
		allOk = false;
	    } else {
		mailApp = "/bin/mail";
		allOk = true;
	    }

	    //  check for /usr/bin/mail
	    if(!allOk) {
		mail = new File("/usr/bin/mail");
		if(!mail.exists()) {
		    announcement = "Could not find '/usr/bin/mail'";
		    allOk = false;
		} else {
		    mailApp = "/usr/bin/mail";
		    allOk = true;
		}
	    }

	    //  check to see if they've typed anything
	    String emailText = textArea.getText();
	    if (emailText.equals(startText)) {
		announcement = "You haven't typed anything...";
		allOk = false;
	    }

	    //  check the flood flags
	    if(hasSentBefore) {
		currentTime = System.currentTimeMillis();
		if(currentTime - timeLastSent < 300000) {
		    announcement = "No more than 1 email every 5 minutes.";
		    allOk = false;
		}
	    }

	    //  send the email
	    if(allOk) {
		Runtime runtime = Runtime.getRuntime();
		try {
		    Process process 
			= runtime.exec(mailApp + " -s Feedback "
				       + "feedback@legowhore.com");
		    OutputStreamWriter outputWriter 
			= new OutputStreamWriter(process.getOutputStream());;
		    BufferedWriter bufferedWriter 
			= new BufferedWriter(outputWriter);
		    bufferedWriter.write(emailText);
		    bufferedWriter.flush();
		    bufferedWriter.close();
		} catch (IOException ioe) {
		    db("trouble sending mail");
		}
		textArea.setText(startText);
		timeLastSent = System.currentTimeMillis();
		hasSentBefore = true;
		announcement = "sent email to LegoWhore...";
	    }
	    q3Gui.effectsPanel.setText(announcement);
	}
    }

    private void db(String s) {
	System.err.println(s);
    }

}
