/*
 * Copyright (C) 2000 Free Software Foundation, Inc.
 * I didn't write this but have no information on who did.
 * If the author steps forward and can prove (somehow) that 
 * they wrote it and have a copyright on it, then I'll gladly remove it.
 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package com.legowhore.q3;

import java.awt.LayoutManager;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Insets;
import java.awt.Component;
import java.util.Vector;

public class PercentLayout implements LayoutManager
{
  private Vector rects, comps;
  
  public PercentLayout()
  {
    rects = new Vector();
    comps = new Vector();
  }

  public void addLayoutComponent(String name, Component comp)
  {
    // First one
    int i = name.indexOf(" ");
    if (i == -1)
      return;
    int x = Integer.valueOf(name.substring(0, i)).intValue();
    if (x < 0 || x > 100)
      return;

    // Second one
    int i2 = name.indexOf(" ", i+1);
    if (i2 == -1)
      return;
    int y = Integer.valueOf(name.substring(i+1, i2)).intValue();
    if (y < 0 || y > 100)
      return;

    // Third one
    int i3 = name.indexOf(" ", i2+1);
    if (i3 == -1)
      return;
    int x2 = Integer.valueOf(name.substring(i2+1, i3)).intValue();
    if (x2 < 0 || x2 > 100)
      return;

    // Fourth one
    int y2 = Integer.valueOf(name.substring(i3 + 1, name.length())).intValue();
    if (y2 < 0 || y2 > 100)
      return;

    rects.addElement(new Rectangle(x, y, x2, y2));
    comps.addElement(comp);
  }

  public void removeLayoutComponent(Component comp)
  {
    int i = comps.indexOf(comp);
    try
    {
      comps.removeElementAt(i);
      rects.removeElementAt(i);
    }
    catch (ArrayIndexOutOfBoundsException e)
    {
      System.err.println("Internal Syncronyzation Error :" + e);
    }
  }

  public Dimension preferredLayoutSize(Container parent)
  {
    // Just sets the preferred size to the largest preferred size of the components
    int xsize = 0;
    int ysize = 0;
    Dimension d;
    for (int i = 0;  i < comps.size(); i++)
    {
      d = ((Component) comps.elementAt(i)).getPreferredSize();
      if(d.width > xsize) xsize = d.width;
      if(d.height > ysize) ysize = d.height;
    }
    Insets insets = parent.getInsets();
    return new Dimension(xsize + insets.left + insets.right,
                         ysize + insets.top + insets.bottom);
  }

  public Dimension minimumLayoutSize(Container parent)
  {
    // Just sets the minimum size to the largest minimum size of the components
    int xsize = 0;
    int ysize = 0;
    Dimension d;
    for (int i = 0;  i < comps.size(); i++)
    {
      d = ((Component) comps.elementAt(i)).getMinimumSize();
      if(d.width > xsize) xsize = d.width;
      if(d.height > ysize) ysize = d.height;
    }
    Insets insets = parent.getInsets();
    return new Dimension(xsize + insets.left + insets.right,
                         ysize + insets.top + insets.bottom);
  }

  public void layoutContainer(Container comp)
  {
    Rectangle r;
    Insets insets = comp.getInsets();
    int w = comp.getSize().width - (insets.left + insets.right);
    int h = comp.getSize().height - (insets.top + insets.bottom);
    int x = insets.left;
    int y = insets.top;
    for (int i = 0; i < comps.size(); i++)
    {
      r = (Rectangle)rects.elementAt(i);
      ((Component)comps.elementAt(i)).setBounds(
        x+((w*r.x)/100),
        y+((h*r.y)/100),
        (x+((w*r.width)/100))-(x+((w*r.x)/100)),
        (y+((h*r.height)/100))-(y+((h*r.y)/100))
        );
    }
  }
}

