/*
 * Copyright (C) 2000 Free Software Foundation, Inc.
 * Brian Satterfield <legowhore@legowhore.com>, 2000.
 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package com.legowhore.q3;

import java.awt.Color;
import java.awt.Font;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.JScrollPane;

public class ServerInfoPanel extends JPanel implements Runnable {

    //  parent
    Q3ServerKit q3Gui;

    //  text area
    JTextArea textArea; 

    //  values
    String mapValue = "";
    String nameValue = "";
    String maxClientsValue = "";
    String timelimitValue = "";
    String fraglimitValue = "";

    JScrollPane scrollPane;

    Font smallFont;

    String summary;

    public ServerInfoPanel(Q3ServerKit q3Gui) {
	this.q3Gui = q3Gui;
	this.setLayout(new PercentLayout());
	
	Border etched = BorderFactory.createEtchedBorder();
	this.setBorder(etched);

	smallFont = new Font("plain", Font.PLAIN, 10); 

	textArea = new JTextArea();
	textArea.setEditable(false);
	textArea.setFont(smallFont);

	summary = "\n";
	summary += summary =  " Server: " + nameValue + " \n";
	summary += "\n";


	summary += " Map: " + mapValue + " \n";
	summary += "\n";


	summary += " Max Clients: " + maxClientsValue + " \n";
	summary += "\n";


	summary += " Time Limit: " + timelimitValue + " \n";
	summary += "\n";


	summary += " Frag Limit: " + fraglimitValue + " \n";
	textArea.setText(summary);
	scrollPane = new JScrollPane(textArea);
	add(scrollPane, "0 0 100 100");

    }

    public void run() {
	textArea.invalidate();
	textArea.setText("");
	summary = "\n";
	summary += " Server: " + nameValue + " \n";
	summary += "\n";
	summary += "\n";

	summary += " Map: " + mapValue + " \n";
	summary += "\n";
	summary += "\n";

	summary += " Max Clients: " + maxClientsValue + " \n";
	summary += "\n";
	summary += "\n";

	summary += " Time Limit: " + timelimitValue + " \n";
	summary += "\n";
	summary += "\n";

	summary += " Frag Limit: " + fraglimitValue + " \n";
	textArea.setText(summary);
	textArea.repaint();
	textArea.validate();
    }

    public void setMap(String map) {
	mapValue = map;
    }
    
    public void setServerName(String name) {
	nameValue = name;
    }

    public void setMaxClients(String maxClients) {
	maxClientsValue = maxClients;
    }

    public void setTimelimit(String timeLimit) {
	timelimitValue = timeLimit;
    }

    public void setFraglimit(String fragLimit) {
	fraglimitValue = fragLimit;
    }

    private void db(String s) {
	System.err.println(s);
    }

}
